#include <stdlib.h>
#include <stdio.h>

#include "../memoire/memoire.h"
#include "../chaine/chaine.h"

#include "vext.h"

static void
afficher_element(void *element)
{
    printf("%s ", (char *) element);
}

static vext
faire_v1(void)
{
    vext v1 = vext_creer();

    vext_ajouter(v1, "10");
    vext_ajouter(v1, "20");
    vext_ajouter(v1, "30");
    vext_ecrire(v1, 1, "40");
    return v1;
}

static vext
faire_v2(void)
{
    vext v2 = vext_creer();

    vext_definir_liberation(v2, memoire_liberer);
    vext_ecrire(v2, 7, chaine_dupliquer("50"));
    vext_ecrire(v2, 5, chaine_dupliquer("60"));
    vext_ajouter(v2, chaine_dupliquer("70"));
    return v2;
}

int
main(int argc, char *argv[])
{
    vext v;

    v = vext_creer();

    vext_definir_liberation(v, vext_liberer);
    vext_ajouter(v, faire_v1());
    vext_ajouter(v, faire_v2());

    printf("\n Premier appel a affichage\n");
    vext_afficher(v);

    printf("\n\n Second appel a affichage\n");
    vext_definir_affichage(v, vext_afficher);
    vext_afficher(v);

    printf("\n\n Troisieme appel a affichage\n");
    vext_definir_affichage(vext_lire(v, 0), afficher_element);
    vext_definir_affichage(vext_lire(v, 1), afficher_element);
    vext_afficher(v);
    printf("\n");

    vext_liberer(v);
    return EXIT_SUCCESS;
}
